﻿@using Microsoft.AspNetCore.Identity
@using CarRental.Core.Models

@inject SignInManager<Account> SignInManager
@inject UserManager<Account> UserManager

@model CarRental.Web.Areas.Accounts.ViewModel.UserEditProfileModel
@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@{
    ViewData["Title"] = "Information User";
    var currentUser = await UserManager.GetUserAsync(User);
    if (await UserManager.IsInRoleAsync(currentUser, ListRoles.CarOwner))
    {
        Layout = "~/Areas/CarOwner/Views/Shared/_Layout.cshtml";
    }
    else if (await UserManager.IsInRoleAsync(currentUser, ListRoles.Customer))
    {
        Layout = "~/Areas/Customer/Views/Shared/_LayoutCustomer.cshtml";
    }
}
<link rel="stylesheet" href="~/css/profile.css">
<link rel="stylesheet" href="/assets/css/form-chang-pass.css">
<div class="container" style=" margin-top: 100px;">
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
            <li class="breadcrumb-item">
                @if (await UserManager.IsInRoleAsync(currentUser, ListRoles.CarOwner))
                {
                    <a asp-action="Index" asp-controller="Home" asp-area="CarOwner">Home</a>
                }
                else if (await UserManager.IsInRoleAsync(currentUser, ListRoles.Customer))
                {
                    <a asp-action="Index" asp-controller="Home" asp-area="Customer">Home</a>
                }
            </li>
            <li class="breadcrumb-item active" aria-current="page">
                My profile
                car
            </li>
        </ol>
    </nav>
    <h1 class="">My profile</h1>
</div>

<section class="mt-3">
    <div class="container" style=" margin-top: 100px;">
        <nav>
            <div class="nav nav-tabs" id="nav-tab" role="tablist">
                <button class="nav-link active text-black" id="nav-booking-tab" data-bs-toggle="tab"
                        data-bs-target="#nav-booking" type="button" role="tab" aria-controls="nav-booking"
                        aria-selected="true">
                    Personal Information
                </button>
                @* <button class="nav-link" id="nav-profile-tab" data-bs-toggle="tab" data-bs-target="#nav-profile" type="button" role="tab" aria-controls="nav-profile" aria-selected="false">
                Security
                </button> *@
                <button id="nav-payment-tab" class="nav-link text-black" data-bs-toggle="tab"
                        data-bs-target="#nav-payment" type="button" role="tab" aria-controls="nav-payment"
                        aria-selected="false">
                    Security
                </button>
            </div>
        </nav>
        <div class="tab-content" id="nav-tabContent">
            <div class="tab-pane fade show active" id="nav-booking" role="tabpanel" aria-labelledby="nav-booking-tab">

                <div class="row mt-5">
                    <form id="signUpForm" asp-area="Accounts" asp-controller="EditProfile" asp-action="EditProfile" method="post"
                          enctype="multipart/form-data" class="form-group" asp-route-username="@User.Identity?.Name">

                        <input type="hidden" asp-for="Address" />
                        <input type="hidden" asp-for="ImageUrlDriverLicense" />

                        <div class="row">
                            <div class="col-md-6">
                                <div class="mb-3">
                                    <label asp-for="FullName" class="form-label">Full Name</label>
                                    <input type="text" asp-for="FullName" class="form-control" placeholder="Full name">
                                    <span asp-validation-for="FullName"></span>
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="mb-3">
                                    <label for="dob" class="form-label">
                                        Date of
                                        birth
                                    </label>
                                    <input type="date" asp-for="DateOfBirth" id="DateOfBirth" class="form-control"
                                           placeholder="Date of birth" aria-describedby="helpId">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <div class="mb-3">
                                    <label for="phone" class="form-label">
                                        Phone
                                        number
                                    </label>
                                    <input type="text" asp-for="PhoneNumber" class="form-control"
                                           placeholder="Phone number" aria-describedby="helpId">
                                </div>
                            </div>
                            <div class="col-md-6">
                                <div class="mb-3">
                                    <label for="email" class="form-label">
                                        Email
                                        address
                                    </label>
                                    <input type="email" asp-for="EmailAddress" class="form-control"
                                           placeholder="Email address" aria-describedby="helpId">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <div class="mb-3">
                                    <label for="email" class="form-label">
                                        National Id No:
                                    </label>
                                    <input type="text" asp-for="NationalIdNo" class="form-control"
                                           placeholder="National Id No" aria-describedby="helpId">
                                </div>
                            </div>
                            <div class="col-md-6">
                                <p><strong>Driver License: </strong></p>
                                <div class="uploader">
                                    <input id="file-upload-1" type="file" asp-for="ImageFileDriverLicense"
                                           accept="image/*" />


                                    <label for="file-upload-1" id="file-drag-1">
                                        <img id="file-image-1" src="#" alt="Preview" class="hidden">
                                        <div id="start-1">
                                            <i class="fa fa-download" aria-hidden="true"></i>
                                            <div>Select a file or drag here</div>
                                            <div id="notimage-1" class="hidden">Please select an image</div>
                                            <span id="file-upload-btn-1" class="btn btn-primary">
                                                Select a
                                                file
                                            </span>
                                        </div>
                                        <div id="response-1" class="hidden">
                                            <div id="messages-1"></div>
                                        </div>
                                    </label>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-6">
                                <label for="address" class="form-label">Address</label>

                                <select name="Address.City" id="City" onchange="loadDistricts()"
                                        class="form-control mb-3" placeholder="City">
                                    @if (ViewBag.Cities != null && Model.Address != null)
                                    {
                                        foreach (var item in ViewBag.Cities)
                                        {
                                            <option value="@item">@item</option>
                                        }
                                    }
                                    @if (Model.Address == null)
                                    {
                                        foreach (var item in ViewBag.Cities)
                                        {
                                            <option value="@item">@item</option>
                                        }

                                    }
                                </select>
                                <select name="Address.District" id="District" onchange="loadWards()"
                                        class="form-control mb-3" placeholder="District">
                                    @if (Model.Address != null)
                                    {
                                        <option value="@Model.Address.District">@Model.Address.District</option>
                                    }
                                </select>
                                <select name="Address.Ward" id="Ward" class="form-control mb-3" placeholder="Ward">
                                    @if (Model.Address != null)
                                    {
                                        <option value="@Model.Address.Ward">@Model.Address.Ward</option>
                                    }
                                </select>


                                <input type="text" asp-for="SpecificAddress" class="form-control mb-3"
                                       placeholder="Home number, Street" aria-describedby="helpId">
                                <span asp-validation-for="SpecificAddress"></span>
                            </div>
                            <div class="col-md-6 mb-3">
                                <p class="mt-3">Already driver license:</p>
                                @if (!string.IsNullOrEmpty(Model.ImageUrlDriverLicense))
                                {
                                    <img src="@Model.ImageUrlDriverLicense" alt="Driver License" style="max-width: 100%;"
                                         class="border border-2" />
                                }
                                @*  <img src="@Url.Content(Model.ImageUrlDriverLicense)"
                                style="max-width: 100%;" class="border border-2" /> *@
                            </div>
                        </div>
                        <div class="row text-end mb-5">
                            <div class="text-center">
                                <button type="reset" class="btn btn-outline-info rounded-1">
                                    Discard
                                </button>
                                <button type="submit" class="btn btn-primary rounded-1">
                                    Save
                                </button>
                            </div>
                        </div>
                    </form>
                </div>

            </div>
            <div class="tab-pane fade" id="nav-payment" role="tabpanel" aria-labelledby="nav-payment-tab">
                <div class="row">
                    <h5 class="mt-5">Change password</h5>
                    <form id="changePasswordform"class="form-group">
                        <div class="form-group-second">
                            <label for="CurrentPassword">Current Password</label>
                            <input type="password" id="CurrentPassword" name="CurrentPassword" class="form-control" style="width:40%" />
                        </div>

                        <div class="form-group mb-3">
                            <label for="NewPassword">New Password</label>
                            <input type="password" id="NewPassword" name="NewPassword" class="form-control" style="width:40%" />
                        </div>

                        <div class="form-group">
                            <label for="ConfirmPassword">Confirm Password</label>
                            <input type="password" id="ConfirmPassword" name="ConfirmPassword" class="form-control" style="width:40%" />
                        </div>
                        <div id="errorList"></div>
                        <span class="text-success" id="successMessage"></span>
                        <div class="form-group mt-3">
                            <div class="row text-end mb-5">
                                <div class="text-center">
                                    <button type="reset" class="btn btn-outline-info rounded-1">Discard</button>
                                    <button type="submit" class="btn btn-primary rounded-1">Save</button>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>

            </div>

        </div>

    </div>
</section>

<script src="~/js/edit-profile.js"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>
<script src="https://code.jquery.com/jquery-3.7.1.min.js"></script>
<script src="//cdnjs.cloudflare.com/ajax/libs/toastr.js/latest/js/toastr.min.js"></script>

<script>
    function loadCities() {
        $.get('/Accounts/EditProfile/GetCities', function (data) {
            var citySelect = $('#City');
            citySelect.empty();
            citySelect.append($('<option>').text('Select City').attr('value', ''));
            $.each(data, function (i, item) {
                citySelect.append($('<option>').text(item).attr('value', item));
            });

            // Đảm bảo rằng khi thay đổi thành phố, các quận và phường cũng sẽ cập nhật
            loadDistricts();
        });
    }

    function loadDistricts() {
        var selectedCity = $('#City').val();
        var districtSelect = $('#District');
        districtSelect.empty();
        districtSelect.append($('<option>').text('Select District').attr('value', ''));
        if (selectedCity) {
            $.get('/Accounts/EditProfile/GetDistricts?selectedCity=' + selectedCity, function (data) {
                $.each(data, function (i, item) {
                    districtSelect.append($('<option>').text(item).attr('value', item));
                });

                // Đảm bảo rằng khi thay đổi quận, các phường cũng sẽ cập nhật
                loadWards();
            });
        }
    }

    function loadWards() {
        var selectedCity = $('#City').val();
        var selectedDistrict = $('#District').val();
        var wardSelect = $('#Ward');
        wardSelect.empty();
        wardSelect.append($('<option>').text('Select Ward').attr('value', ''));
        if (selectedCity && selectedDistrict) {
            $.get('/Accounts/EditProfile/GetWards?selectedCity=' + selectedCity + '&selectedDistrict=' + selectedDistrict, function (data) {
                $.each(data, function (i, item) {
                    wardSelect.append($('<option>').text(item).attr('value', item));
                });
            });
        }
    }
    $(document).ready(function () {
        $('#changePasswordform').submit(function (event) {
            event.preventDefault();
            var formData = {
                CurrentPassword: $("#CurrentPassword").val(),
                NewPassword: $("#NewPassword").val(),
                ConfirmPassword: $("#ConfirmPassword").val()
            };

            console.log(formData);

            $.ajax({
                type: "POST",
                url: "/Accounts/EditProfile/ChangePassword", // Điều chỉnh đường dẫn tương ứng với controller và action của bạn
                data: JSON.stringify(formData),
                contentType: "application/json",
                success: function (result) {
                    if (result.success) {
                        window.location.href = result.redirect;
                    } else {
                        $("#errorSpan").text(""); // Xóa bất kỳ lỗi trước đó
                        if (result.errors && result.errors.length > 0) {
                            var errorList = $("#errorList");
                            errorList.empty();
                            result.errors.forEach(function (error) {
                                errorList.append("<div><span class='text-danger'>" + error + "</span></div>");
                            });
                        }
                    }
                },
                error: function () {
                    $("#errorSpan").text("An error occurred while processing your request.");
                }
            });
        });
    });
</script>
